#' A list of fsa files
#'
#' A list of fsa files read into R using trace::read_fsa() that for example data
#'
#' @format ## `cell_line_fsa_list`
#' A list with 92 elements, each one being the contents of an fsa file:
#' @source \doi{10.1038/s41467-024-47485-0}
"cell_line_fsa_list"



#' example_data
#'
#' example_data is genemapper output peak table
#'
#' @format ## `example_data`
#' A genemapper output dataframe
#' @source \doi{10.1038/s41467-024-47485-0}
"example_data"


#' example_data_repeat_table
#'
#' example_data_repeat_table is data with repeats called
#'
#' @format ## `example_data_repeat_table`
#' A genemapper output dataframe
#' @source \doi{10.1038/s41467-024-47485-0}
"example_data_repeat_table"

#' metadata
#'
#' This is a dataframe containing the metadata information for the example data
#'
#' @format ## `metadata`
#' A genemapper output dataframe
#' @source \doi{10.1038/s41467-024-47485-0}
"metadata"
